/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53

import 'dart:async';

import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class a126 {
  
  final Offset a108;

  
  final Offset a107;

  
  final Offset a106;

  
  a126._a198(_a129 a463)
      : a108 = a463.a91,
        a107 = a463.a90 - a463.a91,
        a106 =
            a463.a89.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(a126 event);


class a127 extends StatefulWidget {
  
  const a127({
    Key? a464,
    required this.a105,
    this.a104,
    this.a103,
    this.a102,
    this.a101,
    this.a100,
    this.a99,
    this.a97 = kLongPressTimeout,
    this.a98 = kTouchSlop,
    this.a96 = true,
  }) : super(key: a464);

  
  final Widget a105;

  
  final TapEventListener? a104;

  
  final TapEventListener? a103;

  
  final Function()? a102;

  
  final MoveEventListener? a101;

  
  final MoveEventListener? a100;

  
  final MoveEventListener? a99;

  
  final double a98;

  
  final Duration a97;

  
  final bool a96;

  @override
  _a130 createState() => _a130();
}

enum _a128 {
  a95,
  a94,
  a93,
  a92,
}

class _a129 {
  late Offset a91;
  late Offset a90;
  late VelocityTracker a89;

  Offset get a7 => a90 - a91;

  _a129.a199(PointerEvent a465) {
    a91 = a465.localPosition;
    a90 = a91;
    a89 = VelocityTracker.withKind(a465.kind)
      ..addPosition(a465.timeStamp, a465.position);
  }
}

class _a130 extends State<a127> {
  final Map<int, _a129> _a288 = <int, _a129>{};
  _a128 a88 = _a128.a92;
  Timer? a87;
  Offset a86 = Offset.zero;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      child: widget.a105,
      onPointerDown: a33,
      onPointerUp: a30,
      onPointerMove: a32,
      onPointerCancel: a29,
    );
  }

  @override
  void dispose() {
    _a201();
    _a288.clear();
    super.dispose();
  }

  void _a200(int a466) {
    _a288.remove(a466);
  }

  void a33(PointerDownEvent a443) {
    _a288[a443.pointer] = _a129.a199(a443);

    if (a6 == 1) {
      a88 = _a128.a95;
      a28(a443);
    } else {
      a88 = _a128.a92;
    }
  }

  void a32(PointerMoveEvent a442) {
    final a289 = _a288[a442.pointer];

    if (a289 == null) return;

    a289.a90 = a442.localPosition;

    if (!a27(a289)) {
      _a201();
    }

    switch (a88) {
      case _a128.a93:
        if (widget.a96) {
          a289.a91 = a289.a90;
        } else {
          a31(a289, a442);
        }
        break;
      case _a128.a95:
        a31(a289, a442);
        break;
      case _a128.a94:
        a289.a89.addPosition(a442.timeStamp, a442.position);
        widget.a100?.call(a126._a198(a289));
        break;

      default:
        a289.a91 = a289.a90;
        break;
    }
  }

  void a31(_a129 a440, PointerMoveEvent a441) {
    a440.a90 = a441.localPosition;
    if (!a27(a440)) {
      a88 = _a128.a94;
      widget.a101?.call(a126._a198(a440));
    }
  }

  void a30(PointerUpEvent a439) {
    final a290 = _a288[a439.pointer];
    if (a290 == null) return;

    a290.a90 = a439.position;
    if (a88 == _a128.a95) {
      a26(a439.copyWith(position: a290.a91));
    } else if (a88 == _a128.a94) {
      a88 = _a128.a92;
      a290.a89.addPosition(a439.timeStamp, a439.position);

      widget.a99?.call(a126._a198(a290));
    } else if (a88 == _a128.a93) {
      widget.a102?.call();
      a88 = _a128.a92;
    } else {
      a88 = _a128.a92;
    }

    a86 = a439.localPosition;
    _a200(a439.pointer);
  }

  void a29(PointerCancelEvent a438) =>
      _a200(a438.pointer);

  void a28(PointerEvent a437) {
    if (widget.a103 != null) {
      a87?.cancel();
      a87 = Timer(widget.a97, () {
        if (a6 == 1 && _a288.entries.first.key == a437.pointer) {
          a88 = _a128.a93;
          widget.a103!(a437);
          _a201();
        }
      });
    }
  }

  bool a27(_a129 a436) {
    return a436.a7.distance.abs() <= widget.a98;
  }

  void _a201() {
    a87?.cancel();
    a87 = null;
  }

  void a26(PointerEvent a435) {
    widget.a104?.call(a435);
  }

  get a6 => _a288.length;
}
