import 'dart:collection';
import 'dart:convert';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../webview_tracking/webview_tracking.dart';
import 'compression.dart';
import 'element_tree.dart';
import 'render_object_extension.dart';
import 'widgets_binding.dart';


RenderView a234() {
  return a180.a207!.renderView;
}






Future<String> a235({
  required String a497,
  required double a498,
}) async {
  final a335 = _a236();

  final a336 = await a335.a21(
    a429: a498,
    
    a430: null,
    a431: a497,
  );

  
  
  a336[0]['style']['bmp'] =
      'com_contentsquare_rootViewBitmapPlaceholder';

  return json.encode(a336);
}


a143 _a236() {
  final a337 = a234();

  final a338 = a196();

  final a339 = _a240(
    a503: a337,
    a504: a338,
  );

  
  
  return a339!;
}


class a143 {
  
  a143({
    required this.a64,
    required this.a63,
    required this.a62,
    required this.a61,
    required this.a60,
  }) : assert(
          a64.a226 == a63,
          'The global frame of the render object must match the global frame of the node',
        );

  
  final RenderObject a64;

  
  final Rect a63;

  
  final String a62;

  
  final Widget a61;

  
  final UnmodifiableListView<a143> a60;

  
  String get a4 => '${a61.runtimeType}';

  
  Future<UnmodifiableListView<Map<String, dynamic>>> a21({
    required double a429,
    required Rect? a430,
    required String a431,
  }) async {
    assert(
      () {
        final a340 = a64 == a234();

        return (a340 && a430 == null) ||
            (!a340 && a430 != null);
      }(),
      'The parent global frame must be null if and only if this is the root node',
    );

    Future<UnmodifiableListView<Map<String, dynamic>>>
        a237() async {
      return UnmodifiableListView([
        for (final a341 in a60)
          ...await a341.a21(
            a429: a429,
            a430: a63,
            a431: a431,
          )
      ]);
    }

    
    
    
    final a342 = a239(
      a501: a64,
      a502: a430,
    );
    if (!a342) {
      return a237();
    }

    /// A function which executes:
    ///   - [callback] if [renderObject] is associated to a WebView
    ///   - [orElse] otherwise
    T a238<T>(
      T Function(a136 webViewTrackerRenderObject)
          a499, {
      required T Function() a500,
    }) {
      final a343 = this.a64;

      if (a343 is a136) {
        return a499(a343);
      } else {
        return a500();
      }
    }

    return UnmodifiableListView([
      {
        'id': a4,
        'metadata': {
          'class_name': a4,
          
          
          'fullpath': a431 + a193(a62),
        },

        /// "recordingId" should only be mandatory for session replay
        /// On the iOS SDK, the structure is used for both: snapshoting and
        /// session replay features so it ends up mandatory for the screengraph
        /// passed down to the ExternalBridgeInterface.takeSnapshot completion
        /// For this reason, we set temporarily a 'recordingId' value based on
        /// the widget's runtimeType.
        
        'recordingId': a4,
        'style': {
          'height': a63.height * a429,
          'width': a63.width * a429,
          'x': a63.left * a429,
          'y': a63.top * a429,
          'visibility': true,
        },
        
        
        'format': a238((_) => 2, a500: () => 1),
        'children': await a238(
          (webViewTrackerRenderObject) async => [
            await webViewTrackerRenderObject.a73(),
          ],
          a500: () => a237(),
        ),
      },
    ]);
  }
}


bool a239({
  required RenderObject a501,
  required Rect? a502,
}) {
  final a344 = a501.a226 != null &&
      a502 != a501.a226;

  final a345 =
      a501 is a136;

  return a344 || a345;
}


a143? _a240({
  required RenderObject a503,
  required a125 a504,
}) {
  assert(
    a504.a111 == a503,
    '	_getPaintedRenderObjectNode was called with a [ElementNode] in which the '
    'renderObject does not match the given [paintedRenderObject]',
  );

  final a346 = a503.a227;
  final a347 = a503.a226;

  
  
  
  
  
  if (a346 == null || a347 == null) {
    return null;
  }

  final a348 = <a143>[];
  
  
  final a349 = LayerHandle<ContainerLayer>();
  a349.layer = ContainerLayer();

  final a350 = _a144(
    a349.layer!,
    a346,
  );

  
  
  
  a503.paint(a350, Offset.zero);

  
  a349.layer = null;

  
  final a351 = a350.a3;
  for (final a352 in a351) {
    final a353 = _a241(
      a507: a352,
      a508: a504,
    );

    
    
    
    
    
    
    
    
    
    if (a353 != null) {
      final a354 = _a240(
        a503: a352,
        a504: a353,
      );

      if (a354 != null) {
        a348.add(a354);
      }
    }
  }

  
  
  
  
  
  a503.markNeedsPaint();

  return a143(
    a64: a503,
    a63: a347,
    a61: a504.a112,
    a62: a504.a110,
    a60: UnmodifiableListView(a348),
  );
}


class _a144 extends PaintingContext {
  _a144(
    ContainerLayer a505,
    Rect a506, {
    this.a59,
  }) : super(a505, a506);

  
  UnmodifiableListView<RenderObject> get a3 =>
      UnmodifiableListView<RenderObject>(_a355);

  
  final List<RenderObject> _a355 = <RenderObject>[];

  /// This is what is called by a [renderObject] to paint a child.
  @override
  void paintChild(RenderObject child, Offset offset) {
    _a355.add(child);
    a59?.call(child);

    
  }

  
  final void Function(RenderObject child)? a59;

  /// Some render object use [_a144.pushLayer] to paint
  /// their children. This calls [createChildContext] to create a new context on
  /// which the render object will paint its child.
  /// Therefore we need to also return an [_a144] which will
  /// report to this [_a144] the children that tried to be
  /// painted.
  @override
  _a144 createChildContext(
    ContainerLayer childLayer,
    Rect bounds,
  ) {
    return _a144(
      childLayer,
      bounds,
      a59: _a355.add,
    );
  }
}


a125? _a241({
  required RenderObject a507,
  required a125 a508,
}) {
  final a356 = a508;

  
  
  final a357 = List.of([a356]);
  while (a357.isNotEmpty) {
    final a358 = a357.removeAt(0);
    if (a358.a111 == a507) {
      return a358;
    }

    a357.addAll(a358.a109);
  }

  return null;
}
