import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/obfuscation/keep.dart';
import 'package:flutter/foundation.dart';

import 'adapters/adapters.dart';

/// The type of event that is sent from the webview.
@a267
enum ContentsquareJavascriptEventEnum {
  /// Send a pageView event or any kind of gesture.
  sendEvent,

  /// Send an exception.
  sendException,

  /// Send a message.
  sendMessage,

  /// Opt in.
  optIn,

  /// Opt out.
  optOut,

  /// Send transaction.
  sendTransaction,

  /// Send dynamic var.
  sendDynamicVar,
}


const _a359 =
    'CSJavascriptBridge_FlutterJavascriptChannel_';


@visibleForTesting
class a147 {
  
  a147({
    required this.a57,
    required this.a56,
    required this.a55,
  });

  
  final Contentsquare a57;

  
  final ContentsquareJavascriptEventEnum a56;

  
  String get _a242 =>
      '$_a359${a56.name}';

  
  final String? Function() a55;

  
  ContentsquareJavascriptChannel get a1 {
    return ContentsquareJavascriptChannel(
      name: _a242,
      onMessageReceived: (message) async {
        return _a243(message);
      },
    );
  }

  
  Future<void> _a243(String a510) {
    final a360 = jsonDecode(a510) as Map<String, dynamic>;
    return _a244(a57).a12(a360);
  }

  a166 _a244(Contentsquare a511) {
    switch (a56) {
      case ContentsquareJavascriptEventEnum.sendEvent:
        return a157(
          a51: a511,
          a50: a55,
        );
      case ContentsquareJavascriptEventEnum.sendException:
        return a163(a47: a511);
      case ContentsquareJavascriptEventEnum.sendMessage:
        return a162(a48: a511);
      case ContentsquareJavascriptEventEnum.optIn:
        return a149(a54: a511);
      case ContentsquareJavascriptEventEnum.optOut:
        return a150(a53: a511);
      case ContentsquareJavascriptEventEnum.sendTransaction:
        return a164(a46: a511);
      case ContentsquareJavascriptEventEnum.sendDynamicVar:
        return a165(a45: a511);
    }
  }

  
  String a20({
    required String Function(String channelName, String data)
        a428,
  }) =>
      '''
function (${_a244(a57).a0.map((name) => name).join(', ')}) {
  ${a428(_a242, 'JSON.stringify({${_a244(a57).a0.map((name) => '"$name": $name').join(', ')}})')};
}''';
}
